//FFSubmenu=Transfer
//FFName=CopyAndAuthor
//FFPath=CopyAndAuthor.js

/*********************************************************
' CopyAndAuthor.js v1.1
' (C) Heinz Hfling 18.09.2004
' Email: fixfoto@gmx.de
'
' ablauffhig ab Fixfoto V2.76 B:78
' Fixfoto: http://www.j-k-s.com
'
' 21.8.2004 V1.0
' Dieses Script wird als Kameratransferscript angewendet.
' Bei Kameras die ber ein Virtuelles Laufwerk angesprochen werden (USB),
' bernimmt es zwei zustzliche Funktionen
' - Die Exifdaten werden mit einem Copyright Eintrag versehen
' - die Zusatzdateien mit Film/Ton zum Bild, werden ebenfalls 
'   kopiert/verschoben. Hierzu kann angeben werden (Setup)
'   welche Dateierweiterung hierzu in Frage kommt. Standartmssig 
'   wird .MOV .AVI und .MPG verwendet.
' Wenn das Script aus dem Editor oder mit F10 gestartet wird
' erscheint ein Setup Dialog, in dem die Dateierweiterungen sowie
' der Name des Fotografen eingetragen werden kann.
' Die Werte werden im Windows-Registry gespeichert.
' 17.9.2004 V1.1
' Bei erstem Bild wird ein Eingabedialog angezeigt in 
' dem knnen der Exif-Bildkommentar, sowie die IPTC
' "Keywords" eingegeben werden. Diese werden dann in der Registry
' "herbergerettet" und nach dem letzten Bild wieder aus der Registry
' gelscht.
'*********************************************************/

/*@cc_on @*/
/*@set @debon = 0; @*/
/*@if (@debon >0) @*/
var debuger=null;
function Outdebug(s)
{  if (debuger!=null) debuger.Outdebug(s); }
try { var debuger = new ActiveXObject("ComDbg.ComDebugD7"); }
catch(e) {}
/*@else @*/
function Outdebug(s) {}
/*@end @*/

var ff  = eval(FF_GetMajor() + "." + FF_GetMinor()); // -0.10;
if( (ff <2.76) || ((ff==2.76)&&(FF_GetBuild()<78)) )
  FF_ErrorBreak("FixFoto Version 2.76 B78 oder hher erforderlich");

var args = FF_GetParam().split(",");
var argc = args.length;

var fso = new ActiveXObject("Scripting.FileSystemObject");
var extend = FF_GetProfile("CopyAndAuthor","Extensions");
if( (extend==undefined) || (extend=="")) 
     extend=".MOV|.AVI|.MPG";
var exts = extend.split("|");

if (argc<3)
{
 Outdebug("Argc<3");
 SetupDialog();
} else
{
  // Name des transferbildes auf Zielpfad
  var file = FF_GetImageName(0);
  var bidx = parseInt(args[0]);
  var bcnt = parseInt(args[1]);
  var qf   = SplitPath(args[2]); // Pfad+Name mit Quelle des Transferbildes
  var modus = args[3];           //  0=kopieren, 1=verschieben
  var EXIFBesch="";
  var IPTCKeywords="";
  var makeIPTC=0;
 
 
  if( bidx == 1 )
     Input();   // User Input holen ->Registry

  // Werte aus Registry holen

  EXIFBesch=FF_GetProfile("CopyAndAuthor","EXIFBesch");
  IPTCKeywords=FF_GetProfile("CopyAndAuthor","IPTCKeywords");
  if (IPTCKeywords!=0) 
      makeIPTC=1;
  
//
// Zusatzdatein mitkopieren/verschieben
//
  if( (qf!=undefined) && (qf.dir!="") && (qf.dir!="\\") )
  {
    var zf = SplitPath(file);
    for( ext in  exts)
     { 
      qn = qf.dir +  zf.file + exts[ext];
      zn = zf.dir +  zf.file + exts[ext];
      if (fso.FileExists(qn))
        {
          if( modus >= "0")
            fso.CopyFile (qn,zn,true);
          if ( modus == "1")
            fso.DeleteFile (qn,true);        
        }
     }
  }
//
// Exif-Daten ergnzen
//
  if(FF_LoadExif(file))
  {
   var   date = FF_GetExifTag("DateTime");
   if(date == "") date = FF_GetExifTag("DateTimeOriginal");
   if(date == "") date = FF_GetExifTag("DateTimeDigitized");
   if(date != "")
      {
      var   v1 = date.split(" ");
      var   v2 = v1[0].split(":");
      var aut = FF_GetProfile("CopyAndAuthor","Fotograf");
      if( aut  == "") aut= "Heinz Hfling";
      if(FF_SetExifTag("Artist",aut))
         FF_SetExifTag("Copyright1"," " + v2[0] + " "+aut);
      }
   if (EXIFBesch!="")
       FF_SetExifTag("ImageDescription",EXIFBesch);
   FF_SaveExif(file);
  }
//
// IPTC setzen
//
 if( makeIPTC>0)
  if ( FF_LoadIPTC(file) )
   {
    if( IPTCKeywords!="")
      FF_SetIPTC("Keywords",IPTCKeywords);
    FF_SaveIPTC(file);
   }  
  
 
// Registry nach dem letzen Bild lschen 
 if( bidx == bcnt)
 {
  FF_WriteProfile("CopyAndAuthor","EXIFBesch","");
  FF_WriteProfile("CopyAndAuthor","IPTCKeywords","");
 }
}

function Input()
{
//** Start Dialog INPUT **
FF_AddDialog("INPUT",181,118);
FF_AddControl("INPUT","IPTC","GROUP",3,34,174,59);
FF_AddControl("INPUT","Exif","GROUP",3,3,174,28);
FF_AddControl("INPUT","Kommentar","STATIC",6,12,31,11);
FF_AddControl("INPUT","E1","EDIT",36,10,138,18);
FF_AddControl("INPUT","Keywords","STATIC",6,44,27,8);
FF_AddControl("INPUT","E2","EDIT",36,40,138,49);
FF_AddControl("INPUT","&Ok","BUTTON",95,97,81,13);
//** End Dialog INPUT **

var WS_VSCROLL = 0x200000;
var WS_HSCROLL = 0x100000;
var WS_TABSTOP = 0x010000;
var WS_BORDER  = 0x800000;
FF_SetControlStyle("INPUT","E1",WS_VSCROLL + WS_TABSTOP);
FF_SetControlStyle("INPUT","E2",WS_VSCROLL + WS_TABSTOP);
FF_ActivateControl("INPUT","E1");

r = FF_ShowDialog("INPUT");
if(r=="&Ok")
 {
   EXIFBesch = FF_GetControl("INPUT","E1");
   EXIFBesch = EXIFBesch.replace(/\r\n\r\n/g,"\r\n");  // leerzeilen rausnehmen
   EXIFBesch = EXIFBesch.replace(/^\r\n/g,"");         // fhrendes cr rausnehmen
   IPTCKeywords = FF_GetControl("INPUT","E2");
   IPTCKeywords = IPTCKeywords.replace(/\r\n\r\n/g,"\r\n");  // leerzeilen rausnehmen
   IPTCKeywords = IPTCKeywords.replace(/^\r\n/g,"");         // fhrendes cr rausnehmen
   if( IPTCKeywords != "" ) 
      makeIPTC  = 1;
   FF_WriteProfile("CopyAndAuthor","EXIFBesch",EXIFBesch);
   FF_WriteProfile("CopyAndAuthor","IPTCKeywords",IPTCKeywords);
 }
 FF_CloseDialog("INPUT"); 
}


// Dateiextensions zur editierung anbieten
function SetupDialog()
{
//** Start Dialog Setup **
FF_AddDialog("Setup",170,58);
FF_AddControl("Setup","Hier bitte die Dateierweiterungen aufzhlen die","STATIC",4,1,128,11);
FF_AddControl("Setup","beim Kameratransfer mit bearbeitet werden sollen.","STATIC",4,9,128,10);
FF_AddControl("Setup","eExt","EDIT",131,2,37,30);
FF_AddControl("Setup","Ok","BUTTON",133,36,33,10);
FF_AddControl("Setup","Fotograf:","STATIC",5,28,33,9);
FF_AddControl("Setup","eAuthor","SLEDIT",4,36,122,10);
FF_AddControl("Setup"," 2004 H.Hfling","STATIC",4,49,49,7);
//** End Dialog Setup **

var ext = FF_GetProfile("CopyAndAuthor","Extensions");
if( (ext==undefined) || (ext=="")) 
     ext=".MOV|.AVI|.MPG";
FF_SetControl("Setup","eExt",extend.replace(/\|/g,"\r\n"));
FF_SetControl("Setup","eAuthor",FF_GetProfile("CopyAndAuthor","Fotograf"));

r = FF_ShowDialog("Setup");
if(r=="Ok")
 {
  ext = FF_GetControl("Setup","eExt");
  ext = ext.replace(/\r\n\r\n/g,"\r\n");
  ext = ext.replace(/\r\n\r\n/g,"\r\n");
  ext = ext.replace(/\r\n/g,"|");
  ext = ext.replace(/\*/g,"");
  FF_WriteProfile("CopyAndAuthor","Extensions",ext);
  FF_WriteProfile("CopyAndAuthor","Fotograf",FF_GetControl("Setup","eAuthor"));
 }
 FF_CloseDialog("Setup"); 
}   
   
   
// liefert Verzeichnis mit abschlieendem Backslash,
// Dateinamen und Erweiterung mit einleitendem Punkt
function SplitPath(path)
{
 var result = new Object();
 result.dir = fso.GetParentFolderName(path) + "\\";
 result.file = fso.GetBaseName(path);
 result.ext = "." + fso.GetExtensionName(path);
 return result;
}

